#include <stdio.h>
#include <stdlib.h>
#include <allegro.h>
#include "area_de_colisao.h"
const int  quantBits = 16; 
class Jogo {
    public:
        int x;
        int y;
        area_de_colisao blocos[];
        bool podeMovimentarVertical(int n);
        bool podeMovimentarHorizontal(int m);
        //bool podeMovimentarPLado(int m,int n);
        //bool podeMovimentarPCima(int m,int n);
        int movimento(void);
        void principal(void);
        void finalizar(void);
        Jogo(int x, int y);
        ~Jogo();

};
Jogo::Jogo(int a, int b){
    this->x = a; this->y = b;    
}
Jogo:: ~Jogo(){
}
bool Jogo::podeMovimentarVertical(int n){
    bool retorno;
    retorno = false;
    for(int i = 0; i<2;i++){
           if(blocos[i].colideVerticalmenteCom(n,n+90)) retorno = true;
    }
    return !retorno;
}
bool Jogo::podeMovimentarHorizontal(int m){
    bool retorno;
    retorno = false;
    for(int i = 0; i<2;i++){
           if(blocos[i].colideLateralmenteCom(m,m+120)) retorno = true;
    }
    return !retorno;
}
/*bool Jogo::podeMovimentarPCima(int m,int n){
    bool retorno;
    retorno = true;
    if(m < medio.xI && m > medio.xS && n < medio.yS && n > medio.yI){
        retorno = false;
    }
    return retorno;
}*/
int main (void)
{
    Jogo teste(400,400);
    //teste.blocos[0].setCoordenadas(0,400,670,400);
    teste.blocos[1].setCoordenadas(588,334,794,390);
    teste.movimento();
    readkey();
    teste.finalizar();
}
//ATENO COLISO PROCURAR POR PPCOL
int Jogo::movimento (void)//COMEO DA EXIBIO!!!!!!
{
allegro_init();

install_keyboard();
install_timer();
set_color_depth(quantBits);
set_gfx_mode(GFX_AUTODETECT, 800, 600,0,0);

BITMAP *buf;
BITMAP *veia;
BITMAP *fundo;
bool moveu = false;
bool mLeft = false;
bool caindo = false;
int ves;
int ves2;

 
buf = create_bitmap(800,600);
veia = create_bitmap(100,100);
fundo = load_bitmap("fundo.bmp",NULL);

int c = 0;
int r = 0;         

BITMAP *velha_andando[] = {load_bitmap("an1.bmp",NULL),load_bitmap("an2.bmp",NULL),
                           load_bitmap("an3.bmp",NULL),load_bitmap("an4.bmp",NULL),
                           load_bitmap("an5.bmp",NULL),load_bitmap("an6.bmp",NULL),
                           load_bitmap("an7.bmp",NULL),load_bitmap("an8.bmp",NULL),
                           load_bitmap("an9.bmp",NULL),load_bitmap("an10.bmp",NULL),
                           load_bitmap("an11.bmp",NULL),load_bitmap("an12.bmp",NULL)};
BITMAP *velha_pulando[] = {load_bitmap("pu0.bmp",NULL),load_bitmap("pu2.bmp",NULL),
                           load_bitmap("pu3.bmp",NULL),load_bitmap("pu4.bmp",NULL),
                           load_bitmap("pu5.bmp",NULL)};

     
 while(!key[KEY_ESC]){//Execuo GERAL!!!!
	 moveu = false;
	 if(key[KEY_LEFT] && this->x > 16 && (podeMovimentarHorizontal(this->x - 10) || podeMovimentarVertical(this->y))) {
           rest(40);
           moveu = true;
           mLeft = true;
           ves = ves % 12;
           this->x = this->x - 10;
           clear(buf);
           veia = velha_andando[ves];
           draw_sprite(buf,fundo, 0,0);
           draw_sprite_h_flip(buf,veia, this->x, this->y);
           draw_sprite(screen,buf, 0, 0);
           ves++;
     }
     if(key[KEY_RIGHT] && this->x < 670 && (podeMovimentarHorizontal(this->x + 10)||podeMovimentarVertical(this->y))){
           rest(40);
           moveu = true;
           mLeft = false;
           ves2 = ves2 % 11;
           this->x = this->x + 10;
           clear(buf);
           veia = velha_andando[ves2];
           draw_sprite(buf,fundo, 0,0);
           draw_sprite(buf,veia, this->x, this->y);
           draw_sprite(screen,buf, 0, 0);
           ves2++; 
     }
     //GRAVIDADE!!!!!
     if((podeMovimentarVertical(this->y)||podeMovimentarHorizontal(this->x))&& caindo){
           int m = 0;
           while((podeMovimentarVertical(this->y +6*m)||podeMovimentarHorizontal(this->x))&& this->y + 6*m < 400){
                 this->y = this->y + 6*m;
                 rest(50);
                 veia = velha_pulando[3];
                 clear(buf);
                 draw_sprite(buf,fundo, 0,0);
                 if(key[KEY_RIGHT] && this->x < 660 && (podeMovimentarHorizontal(this-> x + 16)||podeMovimentarVertical(this->y + 2*m))){
                       this->x = this->x + 16;
                       mLeft = false;
                     
                 }
                 if(key[KEY_LEFT] && this->x > 16 && podeMovimentarHorizontal(this->x - 16)){
                       this->x = this->x - 16;
                       mLeft = true;
                 }
                 if(mLeft){  
                       draw_sprite_h_flip(buf,veia, this->x,this->y);
                 }else{
                       draw_sprite(buf,veia, this->x,this->y);
                 }
                 draw_sprite(screen,buf, 0, 0);
                 m++;
           }
           caindo = false;
     }
     int m = 0;
     int num = 0;
     if(key[KEY_S]){
           moveu = true;
           
           int gravidade[] = {136,30,24,18,12,6,3/*,0,0,-8,-16,-24,-32,-40,-48,-56,-64*/};
           while(m < /*17*/7){
                 rest(50);
                 if(podeMovimentarHorizontal(this->x)||podeMovimentarVertical(this->y - gravidade[m])){
                      
                       this->y = this->y - gravidade[m];
                 }/*else{
                       m = 17 - m;
                       this->y = this->y - gravidade[m];
                      // taAlto = true;
                      
                       //break;
                       
                 }*/
                 if(m==0){
                       veia = velha_pulando[0];                       
                 }
                 if(m > 0 && m < 2){
                       veia = velha_pulando[1];
                 }
                 if(m==3){
                       veia = velha_pulando[2];
                 }
                 if(m>3 && m < 7){
                       veia = velha_pulando[4];
                 }
                 /*if(m==17){
                       veia = velha_pulando[4];
                 }*/
                 clear(buf);
                 //textout(buf,font,"TRavou aqui", 0, 0, 80);
                 draw_sprite(buf,fundo, 0,0);
                 if(key[KEY_RIGHT] && this->x < 660 && (podeMovimentarHorizontal(this-> x + 16)||podeMovimentarVertical(this->y- gravidade[m]))){
                       this->x = this->x + 16;
                       mLeft = false;
                 }
                 if(key[KEY_LEFT] && this->x > 16 && podeMovimentarHorizontal(this->x - 16)){
                       this->x = this->x - 16;
                       mLeft = true;
                 }
                 if(mLeft){  
                       draw_sprite_h_flip(buf,veia, this->x,this->y);
                 }else{
                       draw_sprite(buf,veia, this->x,this->y);
                 }
                 draw_sprite(screen,buf, 0, 0);
                 m++;
           }
           
     }
     if((podeMovimentarVertical(this->y)||podeMovimentarHorizontal(this->x))&& y < 400){
           caindo = true;
     }
     if(!moveu){
           clear(buf);
           draw_sprite(buf,fundo, 0,0);
           veia = load_bitmap("an0.bmp",NULL);
           if(mLeft){  
                 draw_sprite_h_flip(buf,veia, this->x,this->y);
           }else{
                 draw_sprite(buf,veia, this->x,this->y);
           }
           draw_sprite(screen,buf, 0, 0);  
    }
     
 }
readkey();
}
END_OF_MAIN();
void Jogo:: finalizar(void){
    remove_timer();
    allegro_exit();
}

